
/* Chrysalide - Outil d'analyse de fichiers binaires
 * return.h - prototypes pour la représentation des ordres de retour
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_RETURN_H
#define _DECOMP_EXPR_RETURN_H


#include <glib-object.h>


#include "../expression.h"
#include "../instruction.h"



#define G_TYPE_RETURN_EXPRESSION               g_return_expression_get_type()
#define G_RETURN_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_return_expression_get_type(), GReturnExpression))
#define G_IS_RETURN_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_return_expression_get_type()))
#define G_RETURN_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_RETURN_EXPRESSION, GReturnExpressionClass))
#define G_IS_RETURN_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_RETURN_EXPRESSION))
#define G_RETURN_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_RETURN_EXPRESSION, GReturnExpressionClass))



/* Définition d'un ordre de retour (instance) */
typedef struct _GReturnExpression GReturnExpression;

/* Définition d'un ordre de retour (classe) */
typedef struct _GReturnExpressionClass GReturnExpressionClass;


/* Indique le type défini pour un ordre de retour. */
GType g_return_expression_get_type(void);

/* Constitue un ordre de retour vers l'appelant. */
GDecInstruction *g_return_expression_new(GDecExpression *);



#endif  /* _DECOMP_EXPR_RETURN_H */
